# XML Node
[XML Tree]

## Read Flags

#define | GWEN_XML_FLAGS_DEFAULT
#define | GWEN_XML_FLAGS_HANDLE_HEADERS 0x1000
#define | GWEN_XML_FLAGS_HANDLE_OPEN_HTMLTAGS 0x0040
#define | GWEN_XML_FLAGS_IGNORE_DESCR 0x0200
#define | GWEN_XML_FLAGS_IGNORE_INCLUDE 0x0008
#define | GWEN_XML_FLAGS_INCLUDE_TO_TOPLEVEL 0x0004
#define | GWEN_XML_FLAGS_INDENT 0x0020
#define | GWEN_XML_FLAGS_KEEP_BLANKS 0x0400
#define | GWEN_XML_FLAGS_KEEP_CNTRL 0x0100
#define | GWEN_XML_FLAGS_NO_CONDENSE 0x0080
#define | GWEN_XML_FLAGS_READ_COMMENTS 0x0001
#define | GWEN_XML_FLAGS_SHARE_TOPLEVEL 0x0002
#define | GWEN_XML_FLAGS_SIMPLE 0x0800
#define | GWEN_XML_FLAGS_WRITE_COMMENTS 0x0010

## Reading And Writing From/To Streams

GWENHYWFAR_API int | GWEN_XML_Parse (GWEN_XMLNODE *n, GWEN_BUFFEREDIO *bio, GWEN_TYPE_UINT32 flags)
GWENHYWFAR_API int | GWEN_XML_ReadFile (GWEN_XMLNODE *n, const char *filepath, GWEN_TYPE_UINT32 flags)
GWENHYWFAR_API int | GWEN_XML_ReadFileSearch (GWEN_XMLNODE *n, const char *filepath, GWEN_TYPE_UINT32 flags, GWEN_STRINGLIST *searchPath)
GWENHYWFAR_API int | GWEN_XMLNode_NormalizeNameSpaces (GWEN_XMLNODE *n)
GWENHYWFAR_API int | GWEN_XMLNode_WriteFile (const GWEN_XMLNODE *n, const char *fname, GWEN_TYPE_UINT32 flags)
GWENHYWFAR_API int | GWEN_XMLNode_WriteToStream (const GWEN_XMLNODE *n, GWEN_BUFFEREDIO *bio, GWEN_TYPE_UINT32 flags)

## Managing Nodes

GWENHYWFAR_API void | GWEN_XMLNode_AddChild (GWEN_XMLNODE *n, GWEN_XMLNODE *child)
GWENHYWFAR_API void | GWEN_XMLNode_AddChildrenOnly (GWEN_XMLNODE *n, GWEN_XMLNODE *nn, int copythem)
GWENHYWFAR_API GWEN_XMLNODE * | GWEN_XMLNode_FindNode (const GWEN_XMLNODE *n, GWEN_XMLNODE_TYPE t, const char *data)
GWENHYWFAR_API void | GWEN_XMLNode_RemoveChildren (GWEN_XMLNODE *n)
GWENHYWFAR_API void | GWEN_XMLNode_UnlinkChild (GWEN_XMLNODE *n, GWEN_XMLNODE *child)

## Managing Headers

Headers are special tags in XML files which describe the document (such as <?xml?> or <!DOCTYPE>).

If the flag GWEN_XML_FLAGS_HANDLE_HEADERS is on upon reading of files these special toplevel tags are added to the current node's header list instead of the normal children node list.

If the same flag is given when writing files the header tags of the given root node are written to the output stream before its children.

Header nodes are identified as nodes whose name begins with '?' or '!'.

GWENHYWFAR_API void | GWEN_XMLNode_AddHeader (GWEN_XMLNODE *root, GWEN_XMLNODE *nh)
GWENHYWFAR_API void | GWEN_XMLNode_ClearHeaders (GWEN_XMLNODE *root)
GWENHYWFAR_API void | GWEN_XMLNode_DelHeader (GWEN_XMLNODE *root, GWEN_XMLNODE *nh)
GWENHYWFAR_API GWEN_XMLNODE * | GWEN_XMLNode_GetHeader (const GWEN_XMLNODE *n)

## Managing Properties/Attributes

A property (in XML notation this is called attribute) is given within a tag (in XML notation this is called element), like in this example:

     <tag property="1" />

GWENHYWFAR_API void | GWEN_XMLNode_CopyProperties (GWEN_XMLNODE *tn, const GWEN_XMLNODE *sn, int overwrite)
GWENHYWFAR_API const char * | GWEN_XMLNode_GetProperty (const GWEN_XMLNODE *n, const char *name, const char *defaultValue)
GWENHYWFAR_API void | GWEN_XMLNode_SetProperty (GWEN_XMLNODE *n, const char *name, const char *value)

## Usage Counter

The usage counter of a node is only used by applications, not by Gwenhywfar itself. So if the application does not set this counter it will always be zero. An application could use this counter to check whether a given node is still in use by some parts of the application in order to free unused nodes.
GWENHYWFAR_API void | GWEN_XMLNode_DecUsage (GWEN_XMLNODE *n)
GWENHYWFAR_API GWEN_TYPE_UINT32 | GWEN_XMLNode_GetUsage (const GWEN_XMLNODE *n)
GWENHYWFAR_API void | GWEN_XMLNode_IncUsage (GWEN_XMLNODE *n)

## Debugging

GWENHYWFAR_API void | GWEN_XMLNode_Dump (const GWEN_XMLNODE *n, FILE *f, int ind)

## Constructors and Destructors

GWENHYWFAR_API GWEN_XMLNODE * | GWEN_XMLNode_dup (const GWEN_XMLNODE *n)
GWENHYWFAR_API void | GWEN_XMLNode_free (GWEN_XMLNODE *n)
GWENHYWFAR_API void | GWEN_XMLNode_freeAll (GWEN_XMLNODE *n)
GWENHYWFAR_API GWEN_XMLNODE * | GWEN_XMLNode_fromString (const char *s, int len, GWEN_TYPE_UINT32 flags)
GWENHYWFAR_API GWEN_XMLNODE * | GWEN_XMLNode_new (GWEN_XMLNODE_TYPE t, const char *data)

## Iterating Through an XML Tree

GWENHYWFAR_API GWEN_XMLNODE * | GWEN_XMLNode_FindFirstTag (const GWEN_XMLNODE *n, const char *tname, const char *pname, const char *pvalue)
GWENHYWFAR_API GWEN_XMLNODE * | GWEN_XMLNode_FindNextTag (const GWEN_XMLNODE *n, const char *tname, const char *pname, const char *pvalue)
GWENHYWFAR_API GWEN_XMLNODE * | GWEN_XMLNode_GetChild (const GWEN_XMLNODE *n)
GWENHYWFAR_API GWEN_XMLNODE * | GWEN_XMLNode_GetFirstData (const GWEN_XMLNODE *n)
GWENHYWFAR_API GWEN_XMLNODE * | GWEN_XMLNode_GetFirstTag (const GWEN_XMLNODE *n)
GWENHYWFAR_API GWEN_XMLNODE * | GWEN_XMLNode_GetNextData (const GWEN_XMLNODE *n)
GWENHYWFAR_API GWEN_XMLNODE * | GWEN_XMLNode_GetNextTag (const GWEN_XMLNODE *n)
GWENHYWFAR_API GWEN_XMLNODE * | GWEN_XMLNode_GetNodeByXPath (GWEN_XMLNODE *n, const char *path, GWEN_TYPE_UINT32 flags)
GWENHYWFAR_API GWEN_XMLNODE * | GWEN_XMLNode_GetParent (const GWEN_XMLNODE *n)
GWENHYWFAR_API int | GWEN_XMLNode_GetXPath (const GWEN_XMLNODE *n1, const GWEN_XMLNODE *n2, GWEN_BUFFER *nbuf)
GWENHYWFAR_API int | GWEN_XMLNode_IsChildOf (const GWEN_XMLNODE *parent, const GWEN_XMLNODE *child)
GWENHYWFAR_API GWEN_XMLNODE * | GWEN_XMLNode_Next (const GWEN_XMLNODE *n)

## Handling Tags As Variables

These functions look for a tag, read their first data element and return it as if it was a DB variable. This simplifies access to simple tags containing simple data tags only. E.g. if your XML structure is this:

     <test>
       <X> 15 </X>
       <Y> 10 </Y>
     </test>

... then you can access the value of X with the following call:

     x=GWEN_XMLNode_GetIntValue(testNode, "X", 0);

If the given variables do not exist or have no value then the also given default value will be returned.

GWENHYWFAR_API const char * | GWEN_XMLNode_GetCharValue (const GWEN_XMLNODE *n, const char *name, const char *defValue)
GWENHYWFAR_API int | GWEN_XMLNode_GetIntValue (const GWEN_XMLNODE *n, const char *name, int defValue)
GWENHYWFAR_API const char * | GWEN_XMLNode_GetLocalizedCharValue (const GWEN_XMLNODE *n, const char *name, const char *defValue)
GWENHYWFAR_API void | GWEN_XMLNode_SetCharValue (GWEN_XMLNODE *n, const char *name, const char *value)
GWENHYWFAR_API void | GWEN_XMLNode_SetIntValue (GWEN_XMLNODE *n, const char *name, int value)

## Type And Data

GWENHYWFAR_API const char * | GWEN_XMLNode_GetData (const GWEN_XMLNODE *n)
GWENHYWFAR_API GWEN_XMLNODE_TYPE | GWEN_XMLNode_GetType (const GWEN_XMLNODE *n)
GWENHYWFAR_API void | GWEN_XMLNode_SetData (GWEN_XMLNODE *n, const char *data)

## Typedefs

typedef int(* | GWEN_XML_INCLUDE_FN )(GWEN_XMLNODE *n, const char *path, const char *file, GWEN_STRINGLIST *sl, GWEN_TYPE_UINT32 flags)
typedef GWEN__XMLNODE | GWEN_XMLNODE

## Enumerations

enum | GWEN_XMLNODE_TYPE { GWEN_XMLNodeTypeTag = 0, GWEN_XMLNodeTypeData, GWEN_XMLNodeTypeComment }

## Functions

| GWEN_LIST2_FUNCTION_LIB_DEFS (GWEN_XMLNODE, GWEN_XMLNode, GWENHYWFAR_API)

## Define Documentation

#define GWEN_XML_FLAGS_DEFAULT

Value:

    (\
      GWEN_XML_FLAGS_INDENT | \
      GWEN_XML_FLAGS_WRITE_COMMENTS\
      )

combination of other flags resembling the default flags

#define GWEN_XML_FLAGS_HANDLE_HEADERS 0x1000

| apply special treatment to toplevel header tags (such as <?xml>)

#define GWEN_XML_FLAGS_HANDLE_OPEN_HTMLTAGS 0x0040

| Let the parser accept some HTML which are known to be unclosed (e.g. the tag "BR" in HTML tags is never closed). If not set a "BR" tag without a corresponding "/BR" will produce an error.

#define GWEN_XML_FLAGS_IGNORE_DESCR 0x0200

| If set then DESCR tags are ignored when reading XML files.

#define GWEN_XML_FLAGS_IGNORE_INCLUDE 0x0008

| if set then include tags/elements are treated as any other tag (i.e. no automatic file inclusion takes place. Instead the include tag is stored like any other tag would be).

#define GWEN_XML_FLAGS_INCLUDE_TO_TOPLEVEL 0x0004

| if set then the file given to the include tag/element are loaded to the root of the XML tree regardless of the tag's location.

#define GWEN_XML_FLAGS_INDENT 0x0020

| Indent lines according to node level when writing nodes. This increases the readability of the resulting file.

#define GWEN_XML_FLAGS_KEEP_BLANKS 0x0400

#define GWEN_XML_FLAGS_KEEP_CNTRL 0x0100

| If set then control characters (such as CR, LF) will not be removed from data.

#define GWEN_XML_FLAGS_NO_CONDENSE 0x0080

| If set then data will not be condensed (e.g. multiple spaces will not be replaced by a single one).

#define GWEN_XML_FLAGS_READ_COMMENTS 0x0001

| if set then comments are read. Otherwise they are ignored when reading a file

#define GWEN_XML_FLAGS_SHARE_TOPLEVEL 0x0002

| if set then toplevel elements are shared across all files (even included ones, if the include tag/element appears in the top level)

#define GWEN_XML_FLAGS_SIMPLE 0x0800

#define GWEN_XML_FLAGS_WRITE_COMMENTS 0x0010

| Also write comments when writing a node.

## Typedef Documentation

typedef int(* GWEN_XML_INCLUDE_FN)(GWEN_XMLNODE *n, const char *path, const char *file, GWEN_STRINGLIST *sl, GWEN_TYPE_UINT32 flags)

typedef struct GWEN__XMLNODE GWEN_XMLNODE

| The abstract type XMLNODE. Each node is one node in the document tree and can represent different things, see GWEN_XMLNODE_TYPE.

## Enumeration Type Documentation

enum GWEN_XMLNODE_TYPE

The possible types of a GWEN_XMLNODE.

Enumerator:

  GWEN_XMLNodeTypeTag | A node can be a tag (in XML notation these are called elements).
  GWEN_XMLNodeTypeData | A node can be some data.
  GWEN_XMLNodeTypeComment | A node can be some XML comment.

## Function Documentation

GWEN_LIST2_FUNCTION_LIB_DEFS | ( | GWEN_XMLNODE | ,
|  | GWEN_XMLNode | ,
|  | GWENHYWFAR_API |
| ) |

GWENHYWFAR_API int GWEN_XML_Parse | ( | GWEN_XMLNODE * | n,
|  | GWEN_BUFFEREDIO * | bio,
|  | GWEN_TYPE_UINT32 | flags
| ) |

| Reads exactly ONE tag/element (and all its subtags) from the given bufferedIO.

GWENHYWFAR_API int GWEN_XML_ReadFile | ( | GWEN_XMLNODE * | n,
|  | const char * | filepath,
|  | GWEN_TYPE_UINT32 | flags
| ) |

| Reads all tags/elements from a file and adds them as children to the given node.

GWENHYWFAR_API int GWEN_XML_ReadFileSearch | ( | GWEN_XMLNODE * | n,
|  | const char * | filepath,
|  | GWEN_TYPE_UINT32 | flags,
|  | GWEN_STRINGLIST * | searchPath
| ) |

Reads the given file. If the path is an absolute one it will be used directly. If it is a relative one the given search path will be searched in case the file with the given name could not be loaded without a search path.

Parameters:

  | n | XML node to store the read tags/elements in
  | filepath | name (and optionally path) of the file to read
  | flags | see GWEN_XML_FLAGS_DEFAULT and others
  | searchPath | a string list containing multiple multiple directories to scan if the file could not be opened directly

GWENHYWFAR_API void GWEN_XMLNode_AddChild | ( | GWEN_XMLNODE * | n,
|  | GWEN_XMLNODE * | child
| ) |

Adds a node as a child to another one. This function does not make deep copies. Instead it takes over ownership of the new child.

Parameters:

  | n | node to which the new node is to be added (i.e. the node which becomes the parent of the second argument)
  | child | child which is to be added (this function takes over ownership of that node, so you MUST NOT free the node yourself)

GWENHYWFAR_API void GWEN_XMLNode_AddChildrenOnly | ( | GWEN_XMLNODE * | n,
|  | GWEN_XMLNODE * | nn,
|  | int | copythem
| ) |

Adds the children of the second argument as new children to the first one.

Parameters:

  | n | node which is to become parent of the second argument's children
  | nn | node whose children are to be moved.
  | copythem | if 0 then the children will be moved (leaving the node of the second argument without children), otherwise deep copies will be made and the node from the second argument will not be altered. co

GWENHYWFAR_API void GWEN_XMLNode_AddHeader | ( | GWEN_XMLNODE * | root,
|  | GWEN_XMLNODE * | nh
| ) |

| Adds a node as a header to the given root node.

GWENHYWFAR_API void GWEN_XMLNode_ClearHeaders | ( | GWEN_XMLNODE * | root | ) |

| Clears the given root nodes' list of headers. All the tags in the header list are also freed.

GWENHYWFAR_API void GWEN_XMLNode_CopyProperties | ( | GWEN_XMLNODE * | tn,
|  | const GWEN_XMLNODE * | sn,
|  | int | overwrite
| ) |

This function copies the properties/attributes of one tag/element to another one.

Parameters:

  | tn | destination node (must be a tag/element)
  | sn | source node (must be a tag/element)
  | overwrite | if !=0 then existing properties/attributes in the destination node will be overwritten.

GWENHYWFAR_API void GWEN_XMLNode_DecUsage | ( | GWEN_XMLNODE * | n | ) |

GWENHYWFAR_API void GWEN_XMLNode_DelHeader | ( | GWEN_XMLNODE * | root,
|  | GWEN_XMLNODE * | nh
| ) |

| Removes a node from the given root nodes' header list. The header node is just removed from the list, not freed !

GWENHYWFAR_API void GWEN_XMLNode_Dump | ( | const GWEN_XMLNODE * | n,
|  | FILE * | f,
|  | int | ind
| ) |

| Dumps the content of the given XML node and all its children.

GWENHYWFAR_API GWEN_XMLNODE* GWEN_XMLNode_dup | ( | const GWEN_XMLNODE * | n | ) |

| Create and return a deep copy of the given node.

GWENHYWFAR_API GWEN_XMLNODE* GWEN_XMLNode_FindFirstTag | ( | const GWEN_XMLNODE * | n,
|  | const char * | tname,
|  | const char * | pname,
|  | const char * | pvalue
| ) |

Searches for the first matching tag/element below the given one. Lets say you have the following XML file:

      <DEVICES>
        <DEVICE id="dev1" />
        <DEVICE id="dev2" />
      </DEVICES>

If you are looking for a device called "dev2" then you should call this function like this:

       tag=GWEN_XMLNode_FindFirstTag(root, "DEVICE", "id", "dev2");

Returns:
  pointer to the tag/element if found, 0 otherwise

Parameters:

  | n | tag/element below which to search
  | tname | tag/element name (e.g. if the tag is "<TESTTAG>" then the tag name is "TESTTAG"). Wildcards (like "*") are allowed.
  | pname | name of the property/attribute to check (if 0 then no property/attribute comparison takes place). No wildcards allowed.
  | pvalue | optional value of the property/attribute to compare against, wildcards allowed.

GWENHYWFAR_API GWEN_XMLNODE* GWEN_XMLNode_FindNextTag | ( | const GWEN_XMLNODE * | n,
|  | const char * | tname,
|  | const char * | pname,
|  | const char * | pvalue
| ) |

| Searches for the next matching tag/element after the given one one the same level (i.e. the returned element has the same parent node as the given element).

GWENHYWFAR_API GWEN_XMLNODE* GWEN_XMLNode_FindNode | ( | const GWEN_XMLNODE * | n,
|  | GWEN_XMLNODE_TYPE | t,
|  | const char * | data
| ) |

| This is a very primitive function. It looks for a node of the given type and data matching the given one (case-insensitive) below the given node (i.e. if a node is returned it will be a child of the given one).

GWENHYWFAR_API void GWEN_XMLNode_free | ( | GWEN_XMLNODE * | n | ) |

| Free the given node (including its children nodes)

GWENHYWFAR_API void GWEN_XMLNode_freeAll | ( | GWEN_XMLNODE * | n | ) |

| Free the given node and all nodes besides this one. Hmm, this function should not be public, I think I will move it to xml_p.h.

GWENHYWFAR_API GWEN_XMLNODE* GWEN_XMLNode_fromString | ( | const char * | s,
|  | int | len,
|  | GWEN_TYPE_UINT32 | flags
| ) |

GWENHYWFAR_API const char* GWEN_XMLNode_GetCharValue | ( | const GWEN_XMLNODE * | n,
|  | const char * | name,
|  | const char * | defValue
| ) |

Parameters:

  | n | Node which is expected to contain a node of the specified name
  | name | name of the node below n to be looked up
  | defValue | default value to return if the tag did not exist

GWENHYWFAR_API GWEN_XMLNODE* GWEN_XMLNode_GetChild | ( | const GWEN_XMLNODE * | n | ) |

INTERNAL. Descends in the XML tree to the first GWEN_XMLNODE below the given node. The returned node may be a tag/element node, or a property/attribute node, or a data node. You will probably prefer to use GWEN_XMLNode_GetFirstTag() instead of this function.

Returns:
  The first children tag/element, or NULL if none exists.

GWENHYWFAR_API const char* GWEN_XMLNode_GetData | ( | const GWEN_XMLNODE * | n | ) |

| Returns the character data of the given node.

GWENHYWFAR_API GWEN_XMLNODE* GWEN_XMLNode_GetFirstData | ( | const GWEN_XMLNODE * | n | ) |

Descends in the XML tree to the first children data node below the given node.

Different from GWEN_XMLNode_GetChild() this function only looks for another data node and not for a (more general) node.

Returns:
  The first children data node, or NULL if none exists.

GWENHYWFAR_API GWEN_XMLNODE* GWEN_XMLNode_GetFirstTag | ( | const GWEN_XMLNODE * | n | ) |

Descends in the XML tree to the first children tag (in XML notation they are called elements) below the given node.

Different from GWEN_XMLNode_GetChild() this function only looks for another tag/element and not for a (more general) node. You will probably prefer this function instead of GWEN_XMLNode_GetChild().

Returns:
  The first children tag/element, or NULL if none exists.

GWENHYWFAR_API GWEN_XMLNODE* GWEN_XMLNode_GetHeader | ( | const GWEN_XMLNODE * | n | ) |

| Returns the first header tag of the given node. Use GWEN_XMLNode_Next to get the next header tag.

GWENHYWFAR_API int GWEN_XMLNode_GetIntValue | ( | const GWEN_XMLNODE * | n,
|  | const char * | name,
|  | int | defValue
| ) |

Internally calls GWEN_XMLNode_GetCharValue and interpretes the data as an integer which is then returned.

Parameters:

  | n | Node which is expected to contain a node of the specified name
  | name | name of the node below n to be looked up
  | defValue | default value to return if the tag did not exist

GWENHYWFAR_API const char* GWEN_XMLNode_GetLocalizedCharValue | ( | const GWEN_XMLNODE * | n,
|  | const char * | name,
|  | const char * | defValue
| ) |

This function does the same as GWEN_XMLNode_GetCharValue, but it looks for an element with the attribute "lang" which matches the currently selected locale (e.g. "lang=de" for Germany). If there is no localized version of the given element then the first element of that name is used (withouth "lang" attribute). Therefore XML documents used with this function should contain unlocalized elements along with localized ones to provide a fallback.

Parameters:

  | n | Node which is expected to contain a node of the specified name
  | name | name of the node below n to be looked up
  | defValue | default value to return if the tag did not exist

GWENHYWFAR_API GWEN_XMLNODE* GWEN_XMLNode_GetNextData | ( | const GWEN_XMLNODE * | n | ) |

Iterates on the same level in the XML tree from the given data node to the next one on the same level (i.e. the returned element has the same parent node as the given element). An XML element may have multiple data nodes as children, and you use this function to iterate through all of them.

Different from GWEN_XMLNode_Next() this function only looks for another data node and not for a (more general) node.

Returns:
  The next data node on the same level, or NULL if no more data node exists.

GWENHYWFAR_API GWEN_XMLNODE* GWEN_XMLNode_GetNextTag | ( | const GWEN_XMLNODE * | n | ) |

Iterates on the same level in the XML tree from the given tag (in XML notation they are called elements) to the next one on the same level (i.e. the returned element has the same parent node as the given element).

Different from GWEN_XMLNode_Next() this function only looks for another tag/element and not for a (more general) node. You will probably prefer this function instead of GWEN_XMLNode_Next().

Returns:
  The next tag/element on the same level, or NULL if no more element exists.

GWENHYWFAR_API GWEN_XMLNODE* GWEN_XMLNode_GetNodeByXPath | ( | GWEN_XMLNODE * | n,
|  | const char * | path,
|  | GWEN_TYPE_UINT32 | flags
| ) |

Locates a tag by its XPath. Currently attributes are not allowed, and the flag GWEN_PATH_FLAGS_VARIABLE is not supported. Supported types of XPaths are:

- /element[1]/element[2]
- ../../element[5]

and so on. As you can see index numbers are supported. You should not use this function to create a node but rather for node lookups.

GWENHYWFAR_API GWEN_XMLNODE* GWEN_XMLNode_GetParent | ( | const GWEN_XMLNODE * | n | ) |

| Returns the parent node of the given node, or NULL if it already is the root node.

GWENHYWFAR_API const char* GWEN_XMLNode_GetProperty | ( | const GWEN_XMLNODE * | n,
|  | const char * | name,
|  | const char * | defaultValue
| ) |

Returns the value of the given property/attribute (or the default value if the property/attribute does not exist or is empty).

Parameters:

  | n | node (must be a tag/element)
  | name | name of the property/attribute
  | defaultValue | default value to be returned if no value could be retrieved

GWENHYWFAR_API GWEN_XMLNODE_TYPE GWEN_XMLNode_GetType | ( | const GWEN_XMLNODE * | n | ) |

| Returns the type of the given node.

GWENHYWFAR_API GWEN_TYPE_UINT32 GWEN_XMLNode_GetUsage | ( | const GWEN_XMLNODE * | n | ) |

GWENHYWFAR_API int GWEN_XMLNode_GetXPath | ( | const GWEN_XMLNODE * | n1,
|  | const GWEN_XMLNODE * | n2,
|  | GWEN_BUFFER * | nbuf
| ) |

GWENHYWFAR_API void GWEN_XMLNode_IncUsage | ( | GWEN_XMLNODE * | n | ) |

GWENHYWFAR_API int GWEN_XMLNode_IsChildOf | ( | const GWEN_XMLNODE * | parent,
|  | const GWEN_XMLNODE * | child
| ) |

Checks whether the second node is a child of the first one.

Returns:
  0 if statement is not true, !=0 otherwise

GWENHYWFAR_API GWEN_XMLNODE* GWEN_XMLNode_new | ( | GWEN_XMLNODE_TYPE | t,
|  | const char * | data
| ) |

GWENHYWFAR_API GWEN_XMLNODE* GWEN_XMLNode_Next | ( | const GWEN_XMLNODE * | n | ) |

INTERNAL. Iterates on the same level in the XML tree from the given node to the next one on the same level (i.e. the returned node has the same parent node as the given element). The returned node may be a tag/element node, or a property/attribute node, or a data node. You will probably prefer to use GWEN_XMLNode_GetNextTag() instead of this function.

Returns:
  The next node on the same level, or NULL if no more element exists.

GWENHYWFAR_API int GWEN_XMLNode_NormalizeNameSpaces | ( | GWEN_XMLNODE * | n | ) |

| This function removes unnecessary namespaces from the given node and all nodes below.

GWENHYWFAR_API void GWEN_XMLNode_RemoveChildren | ( | GWEN_XMLNODE * | n | ) |

| Unlinks and frees all children of the given node.

GWENHYWFAR_API void GWEN_XMLNode_SetCharValue | ( | GWEN_XMLNODE * | n,
|  | const char * | name,
|  | const char * | value
| ) |

GWENHYWFAR_API void GWEN_XMLNode_SetData | ( | GWEN_XMLNODE * | n,
|  | const char * | data
| ) |

| Set the character data of the given node to the given value. This function will create a deep copy of the character data.

GWENHYWFAR_API void GWEN_XMLNode_SetIntValue | ( | GWEN_XMLNODE * | n,
|  | const char * | name,
|  | int | value
| ) |

GWENHYWFAR_API void GWEN_XMLNode_SetProperty | ( | GWEN_XMLNODE * | n,
|  | const char * | name,
|  | const char * | value
| ) |

Sets the value of a property/attribute. This property/attribute will be created if it does not exist and overwritten if it does.

Parameters:

  | n | node (must be a tag/element)
  | name | name of the property/attribute
  | value | new value of the property/attribute

GWENHYWFAR_API void GWEN_XMLNode_UnlinkChild | ( | GWEN_XMLNODE * | n,
|  | GWEN_XMLNODE * | child
| ) |

Unlinks the given child node from its parent without freeing it. This function relinquishes the ownership of the child to the caller who thereby becomes responsible for freeing this node.

Parameters:

  | n | node which is suspected to be the parent of the second argument
  | child | node which is to be unlinked

GWENHYWFAR_API int GWEN_XMLNode_WriteFile | ( | const GWEN_XMLNODE * | n,
|  | const char * | fname,
|  | GWEN_TYPE_UINT32 | flags
| ) |

| Writes a tag and all its subnodes to the given file.

GWENHYWFAR_API int GWEN_XMLNode_WriteToStream | ( | const GWEN_XMLNODE * | n,
|  | GWEN_BUFFEREDIO * | bio,
|  | GWEN_TYPE_UINT32 | flags
| ) |

| Writes a tag and all its subnodes to the given bufferedio.